/******************************************************************************
 *
 * Copyright (c) 2007, ACCESS Systems Americas, Inc. All Rights Reserved.
 *
 * File: AppMain.c
 *
 *****************************************************************************/

#include <PalmOS.h>
#include <PalmCompatibility.h>

#include <stdlib.h>

#include "CXMLReaderImpl.h"
#include "AppResources.h"



/***********************************************************************
 *
 *	Global variables
 *
 ***********************************************************************/
//short displayWidth, displayHeight;
FormPtr pMainForm;
/***********************************************************************
 *
 *	Entry Points
 *
 ***********************************************************************/


/***********************************************************************
 *
 *	Internal Constants
 *
 ***********************************************************************/
#define appFileCreator			'MIHA'	// register your own at http://www.palmos.com/dev/creatorid/
#define appVersionNum			0x01
#define appPrefID				0x00
#define appPrefVersionNum		0x01


/***********************************************************************
 *
 * FUNCTION:    GetObjectPtr
 *
 * DESCRIPTION: This routine returns a pointer to an object in the active form.
 *
 * PARAMETERS:  objectID - id of the object
 *
 * RETURNED:    pointer to the object's data structure
 *
 ***********************************************************************/
VoidPtr GetObjectPtr(Int objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID)));
}

FileHand outFileH;


void clearFile()
{
	Err error = errNone;
	
    // Tiedoston avaus; muiskortin numero, tiedostonnimi, tyyppi, tekij, moodi, virhe ptr
    outFileH = FileOpen(0, "answers.dat", 0, 'MIHA', fileModeReadWrite, &error);
    //outFileH = FileOpen(0, fileName, 0, 'MIHA', fileModeReadWrite, &error);
	if(error != errNone){
    	ErrAlert(error);
		error = errNone;
	}	
	FileTruncate(outFileH, 0);
	FileClose(outFileH);
}

void openFile(const char* fileName)
{
	Err error = errNone;
	
    // Tiedoston avaus; muiskortin numero, tiedostonnimi, tyyppi, tekij, moodi, virhe ptr
    outFileH = FileOpen(0, fileName, 0, 'MIHA', fileModeAppend, &error);
    //outFileH = FileOpen(0, fileName, 0, 'MIHA', fileModeReadWrite, &error);
	if(error != errNone){
    	ErrAlert(error);
		error = errNone;
	}
}


void writeFile(char* data)
{
	Err error = errNone;
	
	// Tiedostoon kirjoitus, parametrina kahva, kirjoitettava data, lohkon koko ja lohkojen mr 
	FileWrite(outFileH, data, 1, StrLen(data), &error);    
	if(error != errNone){
		ErrAlert(error);
		error = errNone;
	}
                           
}

/*
void writeFile(int num)
{
	Err error = errNone;
	
	// Tiedostoon kirjoitus, parametrina kahva, kirjoitettava data, lohkon koko ja lohkojen mr 
	FileWrite(outFileH, &num, sizeof(int), 1, &error);    
	if(error != errNone){
		ErrAlert(error);
		error = errNone;
	}                           
}*/

void closeFile()
{
	FileClose(outFileH);
}

static void addCheckbox(FormPtr pForm, int id, const char* text, int x, int y, int width)
{
	// Parameters: formPP, ID, style, textP, x, y, width, height, font, group, leftAnchor
	CtlNewControl((void**)&pForm, id, checkboxCtl, text, x, y, width, 10, stdFont, 0, false);
	FrmDrawForm(pForm);
}
/*
static void addButton(FormPtr pForm, int id, const char* text, int x, int y, int width)
{
	// Parameters: formPP, ID, style, textP, x, y, width, height, font, group, leftAnchor
	CtlNewControl((void**)&pForm, id, buttonCtl, text, x, y, width, 10, stdFont, 0, false);
	FrmDrawForm(pForm);
}
*/
static void addSlider(FormPtr pForm, int id, int x, int y, int width, int min, int max, int step, int value)
{	
	CtlNewSliderControl((void**)&pForm, id, sliderCtl , 0, 0, x, y, width, 15, min, max, step, value);
	FrmDrawForm(pForm);
}

static void addLabel(FormPtr pForm, int id, int x, int y, const char* text)
{
	FrmNewLabel(&pForm, id, text, x, y, stdFont);
	FrmDrawForm(pForm);
}

char** list_items;
int    current_list_item = 0;
int    num_list_items = 0;
int    listX = 0;
int    listY = 0;
int    listWidth = 0;
int    listHeight = 0;
int    listNumVisible = 3;
int    listId;

static void addList(FormPtr pForm, int id, int numItems, int x, int y, int width, int height, int numVisible)
{
	list_items = (char**)malloc(sizeof(char*)*numItems);
	num_list_items = numItems;
	current_list_item = 0;
	listX = x;
	listY = y;
	listWidth = width;
	listHeight = height;
	listNumVisible = numVisible;
	listId = id;
}

static void addListItem(FormPtr pForm, int id, const char* text)
{
	list_items[current_list_item] = (char*)malloc(sizeof(char)*strlen(text)+1);
	strcpy(list_items[current_list_item], text);
	list_items[current_list_item][strlen(text)] = '\0';
	current_list_item++;
	
	if (current_list_item == num_list_items) {
		ListPtr pList;		
		LstNewList((void**)&pForm, listId, listX, listY, listWidth, listHeight, stdFont, listNumVisible, 0);
		pList = (ListPtr)GetObjectPtr(listId);
	
		if (pList)
			LstSetListChoices(pList, (char**)list_items, num_list_items);	
		
		FrmDrawForm(pForm);
		
	}
}

void cleanup()
{
	int i;
	if (list_items != NULL) {
		for (i = 0; i < num_list_items; i++) {
			if (list_items[i] != NULL) {
				free(list_items[i]);
				list_items[i] = NULL;
			}
		}
	}
	
	free(list_items);
	list_items = NULL;
	current_list_item = 0;
	num_list_items = 0;
}

/*
void readFile(const char* fileName, char* buffer, size_t bufSize)
{
	FileHand fileH;
    Err error = errNone;
    Int32 fsize = 0;

    memset(buffer, '\0', bufSize);
                
    // Tiedoston avaus; muiskortin numero, tiedostonnimi, tyyppi, tekij, moodi, virhe ptr
    fileH = FileOpen(0, fileName, 0, 'MIHA', fileModeReadOnly, &error);
    if(error != errNone){
	    ErrAlert(error);
        error = errNone;
    }
    
    FileSeek(fileH, 0, fileOriginEnd);
	FileTell(fileH, &fsize, &error);
	FileSeek(fileH, 0, fileOriginBeginning);
	    
	// TODO check that fsize <= bufSize
	
    // Tiedoston luku, parametrit puskuri datalle, luettavan lohkon koko ja lohkojen mr
    FileRead(fileH, buffer, 1, fsize, &error);
    if(error != errNone){
	    ErrAlert(error);
        error = errNone;
    }
                                
    FileClose(fileH);
}
*/

static void TestXMLParser()
{
	clearFile();
	
	//char* buffer = (char*)malloc(16000);
	
	//readFile("questions.xml", buffer, 16000);
		
    //BufferReadCallBack* cp = new BufferReadCallBack(buffer, strlen(buffer));
    FileReadCallBack* cp = new FileReadCallBack("questions.xml");
	CXMLReaderImpl xml = CXMLReaderImpl(cp, true);
	
	//openFile("answers.dat");
	
	while(xml.read())
	{
		switch(xml.getNodeType())
		{
		case EXN_TEXT:
			// Nothing to do here...
			break;
		case EXN_ELEMENT:
			{	
				if (!strcmp("checkbox", xml.getNodeName())) {
					addCheckbox(
						pMainForm,
						xml.getAttributeValueAsInt("id"),
						xml.getAttributeValue("text"),
						xml.getAttributeValueAsInt("x"),
						xml.getAttributeValueAsInt("y"),
						xml.getAttributeValueAsInt("width")
					);
				}
				/*	
				if (!strcmp("button", xml.getNodeName())) {
					addButton(
						pMainForm,
						xml.getAttributeValueAsInt("id"),
						xml.getAttributeValue("text"),
						xml.getAttributeValueAsInt("x"),
						xml.getAttributeValueAsInt("y"),
						xml.getAttributeValueAsInt("width")
					);
				}*/
				
				if (!strcmp("list", xml.getNodeName())) {
					addList(
						pMainForm,
						xml.getAttributeValueAsInt("id"),
						xml.getAttributeValueAsInt("numItems"),
						xml.getAttributeValueAsInt("x"),
						xml.getAttributeValueAsInt("y"),
						xml.getAttributeValueAsInt("width"),
						xml.getAttributeValueAsInt("height"),
						xml.getAttributeValueAsInt("numVisible")
					);
				}								
				
				if (!strcmp("item", xml.getNodeName())) {
					addListItem(
						pMainForm,
						xml.getAttributeValueAsInt("id"),
						xml.getAttributeValue("text")
					);
				}
				
				if (!strcmp("label", xml.getNodeName())) {
					addLabel(
						pMainForm,
						xml.getAttributeValueAsInt("id"),
						xml.getAttributeValueAsInt("x"),
						xml.getAttributeValueAsInt("y"),						
						xml.getAttributeValue("text")
					);
				}
				
				if (!strcmp("slider", xml.getNodeName())) {
					addSlider(
						pMainForm,
						xml.getAttributeValueAsInt("id"),
						xml.getAttributeValueAsInt("x"),
						xml.getAttributeValueAsInt("y"),
						xml.getAttributeValueAsInt("width"),						
						xml.getAttributeValueAsInt("min"),
						xml.getAttributeValueAsInt("max"),
						xml.getAttributeValueAsInt("step"),
						xml.getAttributeValueAsInt("value")						
					);
				}
			}
			break;
			
			default:
			break;
		}
	}
	
	//closeFile();
	//free(buffer);
	//buffer = 0;
}

/***********************************************************************
 *
 * FUNCTION:    MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:  command  - menu item id
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled = false;
	FormType * pForm;

	switch (command) {
		case MainOptionsAboutStarterApp:
			pForm = FrmInitForm(AboutForm);
			FrmDoDialog(pForm);					// Display the About Box.
			FrmDeleteForm(pForm);
			handled = true;
			break;

	}
	
	return handled;
}


/***********************************************************************
 *
 * FUNCTION:    MainFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the 
 *              "MainForm" of this application.
 *
 * PARAMETERS:  pEvent  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormHandleEvent(EventType* pEvent)
{
	Boolean 	handled = false;
	FormType* 	pForm;

	switch (pEvent->eType) {
		case menuEvent:
			return MainFormDoCommand(pEvent->data.menu.itemID);

		case frmOpenEvent:
			pForm = FrmGetActiveForm();
			pMainForm = pForm;
			TestXMLParser();
			FrmDrawForm(pForm);
			handled = true;
			break;
			
		default:			
			break;
	}
	
	return handled;
}


void returnPreviousApp()
{
	Err         err;
	LocalID     dbID = DmFindDatabase(0, "Launcher");
	
	if (dbID) {
		err = SysUIAppSwitch (0,dbID,sysAppLaunchCmdNormalLaunch ,0);
	}	
}


/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 *              handler for the form loaded.
 *
 * PARAMETERS:  event  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean AppHandleEvent(EventType* pEvent)
{
	UInt16 		formId;
	FormType* 	pForm;
	Boolean		handled = false;
	
	if (pEvent->eType == frmLoadEvent) {
		// Load the form resource.
		formId = pEvent->data.frmLoad.formID;
		
		pForm = FrmInitForm(formId);
		FrmSetActiveForm(pForm);

		// Set the event handler for the form.  The handler of the currently
		// active form is called by FrmHandleEvent each time is receives an
		// event.
		switch (formId) {
			case MainForm:
				FrmSetEventHandler(pForm, MainFormHandleEvent);			
				break;

			default:
				break;
		}
		handled = true;
	}
	
	if (pEvent->eType == ctlSelectEvent) {
		
		if (pEvent->data.ctlSelect.controlID == ButtonDone) {			
			//closeFile();
			returnPreviousApp();
		}
		else {
			openFile("answers.dat");		
			char s[maxStrIToALen];
			memset(s, '\0', maxStrIToALen);
			StrIToA(s, pEvent->data.ctlSelect.controlID);
			writeFile(s);
			writeFile(" ");
			memset(s, '\0', maxStrIToALen);
			StrIToA(s, pEvent->data.ctlSelect.value);
			writeFile(s);			
			writeFile("\n");			
			closeFile();
		}
	}
		
	return handled;
}


/***********************************************************************
 *
 * FUNCTION:     AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * PARAMETERS:   nothing
 *
 * RETURNED:     Err value errNone if nothing went wrong
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err AppStart(void)
{
	FrmGotoForm(MainForm);
	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppStop(void)
{
	// Close all the open forms.
	FrmCloseAllForms();
	cleanup();
}


/***********************************************************************
 *
 * FUNCTION:    AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.  
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppEventLoop(void)
{
	Err			error;
	EventType	event;

	do {
		EvtGetEvent(&event, evtWaitForever);

		if (SysHandleEvent(&event))
			continue;
			
		if (MenuHandleEvent(0, &event, &error))
			continue;
			
		if (AppHandleEvent(&event))
			continue;

		FrmDispatchEvent(&event);

	} while (event.eType != appStopEvent);
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY: 
 *
 *
 ***********************************************************************/
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error = errNone;

	switch (cmd) {
		case sysAppLaunchCmdNormalLaunch:
			if ((error = AppStart()) == 0) {			
				AppEventLoop();
				AppStop();
			}
			break;

		default:
			break;
	}
	
	return error;
}


